/*****************************************************************************
*
* Copyright (C) 2003 Atmel Corporation
*
* ̧			: TerminalDriver.c
* ߲		: IAR EWAAVR 2.28a
* 			: 2.1
* ŏIXV		: 18-07-2003 by LTA
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega128
*				  (޲̎xǉɂUARTڼ޽ύXĂB)
*
* 			: [Эڰ ̪
*
****************************************************************************/

#include "TerminalDriver.h"


//	* ̑` (޲̏ꍇ͕ύXĂB) *

/* UARTڼ޽ */
#define UARTBAUD		UBRR0L		// U(S)ARTްڰ ڼ޽
#define UARTSTATUS		UCSR0A		// U(S)ART/ڼ޽A
#define UARTCONTROL		UCSR0B		// U(S)ART/ڼ޽B
#define UARTDATA		UDR0		// U(S)ARTް ڼ޽

#define UARTTXEN		TXEN0		// Mޯ
#define UARTRXEN		RXEN0		// Mޯ
#define UARTTXC			TXC0		// M׸
#define UARTRXC			RXC0		// M׸
#define UARTUDRE		UDRE0		// ް ڼ޽׸

//#define BAUDRATEFACTOR	1		// 115200bps/3.69MHzłUBRRl
#define BAUDRATEFACTOR	11		//  19200bps/3.69MHzłUBRRl
//#define BAUDRATEFACTOR	23		//   9600bps/3.69MHzłUBRRl

//	* ϸ *

/* ߎ菇Jnol */
#define SENDESC            \
    Term_Send( 27 );       \
    Term_Send( '[' );

//	* 2i޲Ēl3ASCIIϊ㑗M *
void Term_Send_Value_as_Digits( unsigned char value )
{
  unsigned char digit;

  digit = '0';					// ASCIIl擾
  while( value >= 100 )			// 100̌l擾
  {
	digit++;					// 100̌ASCIIlis
	value -= 100;				// l-100
  }
  Term_Send( digit );			// 100̌M
  digit = '0';					// ASCIIl擾
  while( value >= 10 )			// 10̌l擾
  {
	digit++;					// 10̌ASCIIlis
	value -= 10;				// l-10
  }
  Term_Send( digit );			// 10̌M
  Term_Send( '0' + value );		// 1̌M
}

//	* UART[ *
void Term_Initialize()
{
  UARTBAUD = BAUDRATEFACTOR;					// U(S)ARTްڰĐݒ
  UARTCONTROL = (1<<UARTTXEN) | (1<<UARTRXEN);	// U(S)ARTM
  Term_Set_Display_Attribute_Mode( MODE_NONE );	// ȑȎSĂ̑
  Term_Erase_Screen();							// ʏ
  Term_Set_Cursor_Position( 1, 1 );				// ٍړ
}

//	* 1޲đM *
void Term_Send( unsigned char data )
{
  while( !(UARTSTATUS & (1<<UARTUDRE)) );		// U(S)ARTް ڼ޽҂
  UARTDATA = data;                              // U(S)ARTMJn
}

//	* 1޲ĎM *
unsigned char Term_Get()
{
  while( !(UARTSTATUS & (1<<UARTRXC)) );		// U(S)ARTM҂
  return UARTDATA;                              // MlƋɕA
}

//	* MESC菇 *
unsigned int Term_Get_Sequence()
{
  unsigned char val;
  unsigned int ret;

  val = Term_Get();			// 1޲ĎMl擾
  if( val != 27 )			// ESCȊOŁA
  {
	ret = val;				// MlԂlƂĐݒ
  }
  else						// ESCŁA
  {
	val = Term_Get();		// 1޲ĎMl擾
	if( val != '[' )		// ESCJnʎqȊOŁA
	{
	  ret = val;			// MlԂlƂĐݒ
	}
	else					// ESCJnʎqŁA
	{
	  val = Term_Get();		// 1޲ĎMl擾
            
	  if( val == 'A' ||		// 󷰂ŁA
		  val == 'B' ||
		  val == 'C' ||
		  val == 'D' )
	  {
		ret = val << 8;		// Ԃl޲Ăɖ󷰕i[
	  }
	  else
	  {
		ret = val;			// MlԂlƂĐݒ
	  }
	}
  }
  return ret;				// Ml܂͖󷰕ƋɕA
}

//	* ׯ ؓ̕񑗐M *
// M޲ĐԂ܂B
unsigned char Term_Send_FlashStr( unsigned char __flash * str )
{
  unsigned char count = 0;	// M޲Čv(l=0)

  while( *str != 0 )		// Iq(0)܂ŕ񑗐M
  {
	Term_Send( *str );		// Ήʒu1޲đM
	str++;					// ʒuwqis
	count++;				// M޲Čvis
  }
  return count;				// M޲ĐƋɕA
}

//	* SRAM̕񑗐M *
// M޲ĐԂ܂B
unsigned char Term_Send_RAMStr( unsigned char * str )
{
  unsigned char count = 0;	// M޲Čv(l=0)

  while( *str != 0 )		// Iq(0)܂ŕ񑗐M
  {
	Term_Send( *str );		// Ήʒu1޲đM
	str++;					// ʒuwqis
	count++;				// M޲Čvis
  }
  return count;				// M޲ĐƋɕA
}

//	* "ٍss܂ŏ"ESC菇M *
void Term_Erase_ScreenBottom()
{
  SENDESC					// 'ESC['M
  Term_Send( 'J' );			// 'J'M
}

//	* "ٍs擪s܂ŏ"ESC菇M *
void Term_Erase_ScreenTop()
{
  SENDESC					// 'ESC['M
  Term_Send( '1' );			// '1'M
  Term_Send( 'J' );			// 'J'M
}

//	* "Sʏ"ESC菇M *
void Term_Erase_Screen()
{
  SENDESC					// 'ESC['M
  Term_Send( '2' );			// '2'M
  Term_Send( 'J' );			// 'J'M
}

//	* "وʒus܂ŏ"ESC菇M *
void Term_Erase_to_End_of_Line()
{
  SENDESC					// 'ESC['M
  Term_Send( 'K' );			// 'K'M
}

//	* "وʒus擪܂ŏ"ESC菇M *
void Term_Erase_to_Start_of_Line()
{
  SENDESC					// 'ESC['M
  Term_Send( '1' );			// '1'M
  Term_Send( 'K' );			// 'K'M
}

//	* "s"ESC菇M *
void Term_Erase_Line()
{
  SENDESC					// 'ESC['M
  Term_Send( '2' );			// '2'M
  Term_Send( 'K' );			// 'K'M
}

//	* "ʐݒ"ESC菇M *
void Term_Set_Display_Attribute_Mode( unsigned char mode )
{
  SENDESC					// 'ESC['M
  Term_Send( mode );		// ʐM
  Term_Send( 'm' );			// ʐݒIq'm'M
}

//	* "Fݒ"ESC菇M *
void Term_Set_Display_Colour( unsigned char fg_bg, unsigned char colour )
{
  SENDESC					// 'ESC['M
  Term_Send( fg_bg );		// F/wiFI𐔎M
  Term_Send( colour );		// FԍM
  Term_Send( 'm' );			// ʐݒIq'm'M
}

//	* "وʒuݒ"ESC菇M *
// オ(1,1)ŁA(X(s),Y())łB
void Term_Set_Cursor_Position( unsigned char row, unsigned char column )
{
  SENDESC									// 'ESC['M
  Term_Send_Value_as_Digits( row );			// s(X)ʒu3őM
  Term_Send( ';' );							// qM
  Term_Send_Value_as_Digits( column );		// (Y)ʒu3őM
  Term_Send( 'H' );							// 'H'M
}

//	* "وړ"ESC菇M *
void Term_Move_Cursor( unsigned char distance, unsigned char direction )
{
  SENDESC									// 'ESC['M
  Term_Send_Value_as_Digits( distance );	// ʒȗΈړʂ3őM
  Term_Send( direction );					// ړ𑗐M
}

//	* "وʒuۑ"ESC菇M *
void Term_Save_Cursor_Position()
{
  SENDESC					// 'ESC['M
  Term_Send( 's' );			// 's'M
}

//	* "وʒu"ESC菇M *
void Term_Restore_Cursor_Position()
{
  SENDESC					// 'ESC['M
  Term_Send( 'u' );			// 'u'M
}

//	* "Sʽ۰ً"ESC菇M *
void Term_Set_Scroll_Mode_All()
{
  SENDESC					// 'ESC['M
  Term_Send( 'r' );			// 'r'M
}

//	* "s͈ͽ۰َw"ESC菇M *
void Term_Set_Scroll_Mode_Limit( unsigned char start, unsigned char end )
{
  SENDESC								// 'ESC['M
  Term_Send_Value_as_Digits( start );	// Jns3őM
  Term_Send( ';' );						// qM
  Term_Send_Value_as_Digits( end );		// Is3őM
  Term_Send( 'r' );						// 'r'M
}

//	* "ʏo"ESC菇M *
void Term_Print_Screen()
{
  SENDESC					// 'ESC['M
  Term_Send( 'i' );			// 'i'M
}

//	* [ɘg` *
void Term_Draw_Frame( unsigned char top, unsigned char left, 
					  unsigned char height, unsigned char width,
					  unsigned char doubleFrame )
{
  static unsigned char __flash edges[] = { 0xDA, 0xBF, 0xC0, 0xD9, 0xC4, 0xB3,		// Pg
										   0xC9, 0xBB, 0xC8, 0xBC, 0xCD, 0xBA };	// 2dg

  unsigned char i = 0;

  height++;													// g܂߂0(ʒu)ɍύX
  width++;													// g܂߂0(ʒu)ɕύX

    /*** Draw frame ***/
  Term_Set_Cursor_Position( top, left );					// وʒugֈړ
  Term_Send( edges[ doubleFrame * 6 + 0 ] );				// ''M
  Term_Set_Cursor_Position( top, left + width );			// وʒugEֈړ
  Term_Send( edges[ doubleFrame * 6 + 1 ] );				// ''M
  Term_Set_Cursor_Position( top + height, left );			// وʒugֈړ
  Term_Send( edges[ doubleFrame * 6 + 2 ] );				// ''M
  Term_Set_Cursor_Position( top + height, left + width );	// وʒugEֈړ
  Term_Send( edges[ doubleFrame * 6 + 3 ] );				// ''M
  for( i = left + 1; i < left + width; i++ )				// r`
  {
	Term_Set_Cursor_Position( top, i );						// [Ήʒuɶوړ
	Term_Send( edges[ doubleFrame * 6 + 4 ] );				// ''M
	Term_Set_Cursor_Position( top + height, i );			// [Ήʒuɶوړ
	Term_Send( edges[ doubleFrame * 6 + 4 ] );				// ''M
  }
  for( i = top + 1; i < top + height; i++ )					// cr`
  {
	Term_Set_Cursor_Position( i, left );					// [Ήʒuɶوړ
	Term_Send( edges[ doubleFrame * 6 + 5 ] );				// ''M
	Term_Set_Cursor_Position( i, left + width );			// E[Ήʒuɶوړ
	Term_Send( edges[ doubleFrame * 6 + 5 ] );				// ''M
  }
}

//	* [ƭ` *
unsigned char Term_Draw_Menu( unsigned char __flash * menu, unsigned char selectPos,
							  unsigned char top, unsigned char left, unsigned char doubleFrame )
{
  unsigned char i, width, height;
  unsigned char __flash * ptr = menu;

  width = height = 0;									// ő區ڕ޲Đƍڐ
  while( *ptr != 0 )									// Iq(0)܂ƭ񏈗
  {
	height++;											// ڐis
	if( selectPos == height )							// ΉڂIԂŁA
	{
	  Term_Set_Display_Attribute_Mode( MODE_REVERSED );	// "]w"M
	}
	else												// ΉڂIԂŁA
	{
	  Term_Set_Display_Attribute_Mode( MODE_NONE );		// "w(]w)"M
	}
	Term_Set_Cursor_Position( top + height, left + 1 );	// Ήڐ擪ʒuɶوʒu

	i = 0;												// ړ޲Čv평
	while( *ptr != '\n' )								// qO܂ōڕ\
	{
	  Term_Send( *ptr );								// ڕΉ޲ĕ\
	  i++;												// ړ޲Čvis
	  ptr++;											// ƭ()ʒuwqis
	}
	ptr++;												// ƭqщz
	if( i > width )										// ړő啶޲ĐXV
	  width = i;
  }
  Term_Set_Display_Attribute_Mode( MODE_NONE );			// "w(]w)"M
  if( selectPos == 0 )									// g`w(selectPos=0)ŁA
  {
	Term_Draw_Frame( top, left, height, width, doubleFrame );	// ƭg\
  }
  Term_Set_Cursor_Position( top + selectPos, left + 1 );		// Iڍ[ɶوړ
  return height;										// ڐƋɕA
}

//	* ƭ *
unsigned char Term_Handle_Menu( unsigned char __flash * menu, unsigned char selectPos,
								unsigned char top, unsigned char left, unsigned char doubleFrame )
{
  unsigned char height;
  unsigned int ret;

  height = Term_Draw_Menu( menu, 0, top, left, doubleFrame );	// g܂߂ƭ\,ڐ擾
  while(1)														// EnterM܂ŖJԂ
  {
	Term_Draw_Menu( menu, selectPos, top, left, doubleFrame );	// Iڂ𔽓]\ōڍĕ`
	ret = Term_Get_Sequence();									// Ml
	if( ret == 13 )						// EnterŁA
	  return selectPos;					// IԍƋɕA
	if( (ret & 0xFF) == 0 )				// 󷰂ŁA
	{
	  ret >>= 8;						// 󷰕޲Ă֕A
	  if( ret == MOVE_UP )				// ''ŁA
	  {
		selectPos--;					// Iԍ(ŏʍڂ1)
		if( selectPos < 1 )				// [ڂ̏ړŁA
		  selectPos = height;			// [ڂ֑IԍύX
	  } else if( ret == MOVE_DOWN )		// ''ŁA
	  {
		selectPos++;					// Iԍis
		if( selectPos > height )		// [ڂ̉ړŁA
		  selectPos = 1;				// [ڂ֑IԍύX
	  }
	}
  }
}
